Creating input files
====================

The images were converted from central cutouts from `ambient-texture.tga`
and `diffuse-alpha-texture.tga` from the [Magnum Shaders test files](https://github.com/mosra/magnum/tree/master/src/Magnum/Shaders/Test/TestFiles):

-   `rgb-63x27.png`
-   `rgb-64x32.png`
-   `rgba-63x27.png`
-   `rgba-64x32.png`
-   `rgba-27x27.png`

`*-slice*.png` files were generated by h-flipping and inverting color channels:

```sh
convert -flop rgba-63x27.png rgba-63x27-slice1.png
convert -flop rgba-27x27.png rgba-27x27-slice1.png
convert -negate -channel RGB rgba-63x27.png rgba-63x27-slice2.png
convert -negate -channel RGB rgba-27x27.png rgba-27x27-slice2.png
pngcrush -ow rgba-63x27-slice1.png
pngcrush -ow rgba-27x27-slice1.png
pngcrush -ow rgba-63x27-slice2.png
pngcrush -ow rgba-27x27-slice2.png
```

They are converted using the official basis universal
[conversion tool](https://github.com/BinomialLLC/basis_universal/#command-line-compression-tool).
For `*.ktx2` files at least version 1.15 is required.

To convert to all the required `*.basis`/`*.ktx2` files, run the `convert.sh`
script.

Creating mipmaps
================

For mipmap testing, the PNG image is resized to two more levels. Using the
box filter, the same as Basis itself, to have the least difference.

```sh
convert rgba-63x27.png -filter box -resize 31x13\! rgba-31x13.png
convert rgba-63x27.png -filter box -resize 15x6\! rgba-15x6.png
convert rgba-31x13.png -rotate 90 rgba-13x31.png
convert rgba-15x6.png -rotate 90 rgba-6x15.png

pngcrush -ow rgba-31x13.png
pngcrush -ow rgba-15x6.png
pngcrush -ow rgba-13x31.png
# For whatever reason, this removes the alpha channel
# 'libpng warning: Invalid number of transparent colors specified'
#pngcrush -ow rgba-6x15.png
```
