Creating input WebP files
=========================

WebP images without alpha channel (`rgb-*.webp`) have been created on Linux OS
using GIMP (GNU Image Manipulation Program). With GIMP one can create lossless
or lossy images with a range of 0-100% image quality, with or without
transparency (alpha channel), although WebP compression algorithm might not be
fruitful when used on very small data because some of the lossy images (e.g.
`rgb-lossy-0.webp`-`748 bytes`) in the test folder are bigger in file size than
their less compressed (eg.`rgb-lossy-45.webp`-`72 bytes`) or even lossless
equivalents (eg.`rgb-lossless.webp`-`54 bytes`). Here is a supporting
explanation on this matter: https://developers.google.com/speed/webp/faq#can_a_webp_image_grow_larger_than_its_source_image

WebP images with alpha channel (`rgba-*.webp`) have been generated by
compressing png images created with GIMP into WebP files. The conversion has
been done on Linux using `cwebp` [WebP encoder](https://developers.google.com/speed/webp/docs/cwebp).

According to the WebP specification, WebP stores pixels exclusively in ARGB
and Y'CbCr -- aka [YUV 4:2:0](https://datatracker.ietf.org/doc/html/rfc6386#section-2)
-- format in [lossless](https://developers.google.com/speed/webp/docs/webp_lossless_bitstream_specification)
and [lossy](https://developers.google.com/speed/webp/faq#what_color_spaces_does_the_webp_format_support)
bitstream respectively. However, WebP gives a lot of flexibility to the user in
terms of compression factor and colorspace choice both in encoding and
decoding, which enables optional creation of/conversion to WebP images in
various formats and image qualities with or without transparency.

The `animated.webp` file was created using https://ezgif.com from two tiny
PNG files.
